""" Script for configuring the build system for SIP-generated Python modules.
"""
import os.path
import sipconfig
import subprocess
from PyQt4 import pyqtconfig
import sys

def _run_cmd(args, suppress_err=False):
    cmdline = " ".join(args)
    sys.stdout.write(cmdline + "\n")
    r = os.system(cmdline)
    if r != 0:
        if not suppress_err:
            sys.stderr.write("Command failed (exit code %d)\n" % (r,))
            # sip should inform the user of the error
        sys.exit(1)
    ''' Why does this not work? (sip bug by the looks of it)
    try: subprocess.check_call(args)
    except subprocess.CalledProcessError, err:
        # sip should inform the user of the error
        sys.exit(1)
    '''

def _sipjoin(*args):
    """ sip expects / path separator regardless of platform. """
    return "/".join(args)

conf = pyqtconfig.Configuration()

# Note that sip expects / for path separator

rootdir = os.path.realpath(_sipjoin(os.path.abspath(os.path.dirname(__file__
    )).replace(os.path.sep, "/"), ".."))
pydir = "%s/python" % (rootdir,)
srcdir = "%s/src" % (rootdir,)

_run_cmd([conf.sip_bin, "-c", ".", "-b", "case.sbf", "-I", conf.pyqt_sip_dir,
        "-e", conf.pyqt_sip_flags, "case.sip"], suppress_err=True)
makefile = pyqtconfig.QtGuiModuleMakefile(conf, "case.sbf", dir=".",
        debug=True)
makefile.generate()
